$fn = 6;

// all measurements in mm (or at least intended that way)

//module rotate_about(a, p=[0,0,0]) { translate(p) rotate(a) translate(-p) children(); } // thanks, peepsalot!

quadpipe_side = 100;
quadpipe_thickness = 4;
quadpipe_inner = quadpipe_side - (2 * quadpipe_thickness);

corner_thickness = quadpipe_thickness;
corner_inner = quadpipe_inner - (2 * corner_thickness);

// the core is the base skeleton minus all folding walls, basically just a big metal cube
core_width = 2500 - quadpipe_side * 6; // 2.55m is maximum allowed in the EU, leave 5cm legal wiggle room; -6*quadpipe_side because we have 3 folding walls on each side
core_length = 8000; // make the thing 5 meters long
core_height = 3000; // 4m is legal maximum, leave wiggle room for wheels and photovoltaics on the roof

core_battery_height = 500; // 50cm in height for battery storage
// corners must be deducted from overall length of the core to get strut lengths
core_strut_width = core_width - 2 * quadpipe_side; 
core_strut_length = core_length - 2 * quadpipe_side;
core_strut_battery_height = core_battery_height - 2 * quadpipe_side;
core_strut_height = core_height - core_strut_battery_height - 3 * quadpipe_side; // adapts main room height to fit batteries and remain within legal limits. this is probably not that good an idea.

hinge_length = 500;
hinge_segments = 8; // has to be dividable by 2 to be symmetric
hinge_segment_length = hinge_length / hinge_segments;
//hinge_thickness = quadpipe_thickness;
hinge_thickness = 15;
//hinge_side_hole = quadpipe_side - hinge_thickness;
hinge_side_hole = 15;
//hinge_270_hole = quadpipe_side * 2 - hinge_thickness;
hinge_270_hole = hinge_side_hole;

hinge_rail_height = 20;
hinge_rail_depth = hinge_side_hole / 2; // width of the "hole" and connectors of hinge rails. hinge_side_hole / 2 chosen at recommendation of InPhase, who is not a structural engineer
//hinge_rail_thickness = 10;
hinge_rail_thickness = quadpipe_thickness;

length_hinge_count = core_length / hinge_length; // FIXME: would be more sensible to derive length from this instead of the other way around

hinge_270_exposed_height = 2 * quadpipe_side + hinge_rail_thickness; // The "outer" height of a 270° hinge NOT a configuration parameter, only there to make calculation more readable
hinge_side_exposed_height = quadpipe_side + hinge_rail_thickness; // ditto

wall_floor_height = core_height - core_battery_height - 3 * quadpipe_side; // 1* quadpipe_side for hinge_side, 2* for hinge_270
//wall_floor_strut_height = wall_floor_height - 2 * quadpipe_side - 2 * hinge_rail_thickness;
wall_floor_strut_height = wall_floor_height - hinge_270_exposed_height - hinge_side_exposed_height + quadpipe_side;

wall_ceiling_height = wall_floor_height - quadpipe_side;
wall_ceiling_strut_height = wall_ceiling_height - hinge_270_exposed_height - hinge_side_exposed_height + quadpipe_side;



wall_side_height = core_height - core_battery_height;
wall_side_strut_height = wall_side_height - 4 * quadpipe_side - 2 * hinge_rail_thickness; 
